Subject: [dnssd] draft-ietf-rtcweb-mdns-ice-candidates-02 feedback

From: Tom Pusateri <[email-masked]>
Date: Sun, 17 Feb 2019 15:13:35 -0500

While this document is an RTCWEB document, it’s more about mDNS and so I’m going to give feedback directly to the authors and the DNS-SD group instead of the RTCWEB group (which I’m not a member). If the authors want to replicate this discussion on RTCWEB, please do so.

Overall, it’s an interesting idea and I think it could work ok. However, I think presentation around ICE, while motivating the idea, is not necessary for a general purpose third party mDNS name aliasing mechanism. I would remove all references to ICE, WebRTC, TURN, etc. and just make a simple mDNS third party name alias registration document.

As part of that, you need to discuss defending the name and responding to queries for the name since the owner of the IP address will not do this.

Section 3.1
===========

List Item 1:

Someone familiar with mDNS would interpret this as an existing registered mDNS host name. I don’t think that’s what this means. I think this means an existing RFC 4122 unique name as described further down in the document.

List Item 3:

This makes it seem like normal mDNS is occurring here when it’s really a 3rd party form of mDNS. So you’re not really following RFC 6762. I don’t think there’s necessarily a problem with 3rd party registrations but don’t point people to RFC 6762 for that. In fact, you’re extending RFC 6762 and you need to describe in more detail how you’re extending it.

3rd last paragraph:

"with both IPv4 and IPv6 addresses MUST expose a different mDNS name for each address."

Again, you’re talking about RFC 4122 unique names, not regular mDNS names as provided by a host. This should be made more clear since it would be common for an mDNS host to use the same name for IPv4 and IPv6.

Section 4
=========

2nd paragraph:

When more than one IPv4 or more than one IPv6 address is present, it seems like it would be better to first prefer an address that is on a shared network instead of always taking the first one (which doesn’t mean anything in DNS). If you want others to use the same address you should prefer the lowest one or the highest one or something sortable instead of the first one which could be different depending on hashing in a cache.

Thanks,
Tom

---

From: Tom Pusateri <[email-masked]>
Date: Sun, 17 Feb 2019 17:30:03 -0500

> On Feb 17, 2019, at 3:13 PM, Tom Pusateri <[email-masked]> wrote:
> 

Thinking about this a little more, I would suggest splitting this into two documents. One that describes an mDNS alias name registration extension to RFC 6 762 and a second document that uses the first document to create unique RFC 4122 names for rtcweb.

Tom

---

From: Tom Pusateri <[email-masked]>
Date: Mon, 18 Feb 2019 08:04:40 -0500

> On Feb 17, 2019, at 5:30 PM, Tom Pusateri <[email-masked]> wrote:
> 

As I’ve thought about this overnight, I’m not convinced that extending mDNS for name aliases is even necessary. If you did, I would definitely want to know the response is not from the owner which means defining a new header bit or new OPT extension.

A simpler way to achieve this would be to just define a new service provided by the name mapper. The mapper can generate unique names for IP addresses as needed and limit their time and scope as it sees fit.

When another process needs to know if a unique .local name resolves to a local IP address, it can locate the name mapper using service discovery (PTR query for _ice-name-mapper._tcp.local, etc.), get the SRV record and ask the target directly.

Tom